$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!
$! Make pre-processing utility files of SHADOW.
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$
$ say 	:== write sys$output
$
$ say " "
$ say "# Making the pre-processing utility modules of SHADOW/VMS #"
$ say " "
$
$!
$! Define the symbols necessary for compilation.
$!
$
$! set on
$! on error then goto CLEANUP
$! on control_c then goto CLEANUP
$! on control_y then goto CLEANUP
$
$ on error then continue
$ on warning then continue
$ on severe then continue
$
$
$!
$! Define the compilation flags. These flags are actually reset in
$! COMPILE.COM, so watch out.
$!
$
$ defines 	:=
$ ccompile 	:= cc'defines'/undefine=(ANSI_LIB)/debug/nooptimize
$ fcompile 	:= fortran'defines'/debug/nooptimize
$ compile	:= @[-.-]compile.com
$
$!
$! The libraries that are created here, and that are used in linking.
$!
$
$ libopcon	= "[-.-.tools.opcon]libopcon.olb"
$ libshadow	= "[-.-.lib]libshadow.olb"
$
$!
$! Go thru all subdirectories (if any) first and make those.
$!
$
$!
$! Compile all the source files.
$!
$
$!
$! create the local library first if it doesn't exist yet.
$!
$
$ compile bragg.for
$ compile ergset.for
$ compile histo3.for
$ compile jntpscalc.for
$ compile patch.for
$ compile pre_mlayer.for
$ compile prerefl.for
$ compile presurface.for
$ compile qeff.for
$ compile readcdf.for
$ compile reflag.for
$
$!
$! Make the final programs in this directory.
$!
$
$!
$! Define the libraries needed to link these programs here.
$!
$
$ libraries 	= "'libopcon'/lib, 'libshadow'/lib"
$
$ say "Linking... bragg"
$ link bragg, 'libraries'
$ say "Linking... ergset"
$ link ergset, 'libraries'
$ say "Linking... histo3"
$ link histo3, 'libraries'
$ say "Linking... jntpscalc"
$ link jntpscalc, 'libraries'
$ say "Linking... patch"
$ link patch, 'libraries'
$ say "Linking... pre_mlayer"
$ link pre_mlayer, 'libraries'
$ say "Linking... prerefl"
$ link prerefl, 'libraries'
$ say "Linking... presurface"
$ link presurface, 'libraries'
$ say "Linking... qeff"
$ link qeff, 'libraries'
$ say "Linking... readcdf"
$ link readcdf, 'libraries'
$ say "Linking... reflag"
$ link reflag, 'libraries'
$
$ say " Copying *.EXE files to UTIL directory "
$ copy/log *.exe [-.-.util]
$ 
$ CLEANUP:
$ say " "
$ say "# Done Making the pre-processing utility modules of SHADOW/VMS #"
$ say " "
$
$ EXIT
